# source https://github.com/sddm/sddm/releases/download/v0.14.0/sddm-0.14.0.tar.xz

Name:		sddm
Version:	0.14.0
Release:	%mkrel 6

License:	GPLv2+
Summary:	QML based X11 desktop manager
Group:		Graphical desktop/KDE5
Url:		https://github.com/sddm/sddm
Source0:	%{name}-%{version}.tar.xz
Source1:    11sddm.conf
Source2:	sddm
Source3:    sddm-autologin.pam
Source4:	sddm.pam
Source5:	Xsession
Source6:	Xsetup
Source7:	sddm.conf
Patch0:		sddm-0.13.0-greeter-fix.patch
Patch1:		sddm-0.13.0-fix-reboot-poweroff-greeter-actions.patch
Patch2:		sddm-0.13.0-fix-session-dir.patch
Patch3:		sddm-0.14.0-fix-avatars.patch
Patch4:     sddm-9999-consolekit.patch
# Patches backported from git
Patch11: 0002-Remove-quotes-from-ServerArguments-696.patch
Patch12: 0003-Add-a-config-option-to-enable-high-DPI-scaling-701.patch
Patch13: 0004-Make-the-default-cursor-themed-705.patch
Patch14: 0005-elarun-Update-date-and-time.patch
Patch15: 0006-Add-Hindi-translations-706.patch
Patch16: 0007-Completed-translation-to-Swedish-709.patch
Patch17: 0008-Support-Non-Latin-characters-in-theme-settings-708.patch
Patch18: 0009-Update-fr.ts-710.patch
Patch19: 0010-add-fish-shell-specific-commands-to-Xsession-and-way.patch
Patch20: 0011-Unlock-Gnome-keyring-on-login-711.patch
Patch21: 0012-releng-Update-create_changelog.pl.patch
Patch22: 0013-releng-Fix-Perl-errors.patch
Patch23: 0014-releng-Support-GitHub-issue-references.patch
Patch24: 0015-Fix-manual-for-Current-theme-setting.patch
Patch25: 0016-add-kwallet5-support.patch
Patch27: 0017-Implemented-kwallet5-for-autologon-as-well.patch
Patch28: 0018-Failure-log-messages-if-gnome-keyring-is-not-install.patch
Patch29: 0019-Cleanup-dangling-pointer-in-SocketServer-725.patch
Patch30: 0020-Fix-all-incorrect-use-of-QStringLiteral.patch
Patch32: 0021-Fix-QStringLiteral.patch

BuildRequires:	cmake
BuildRequires:  %{_lib}pam-devel
BuildRequires:	%{_lib}qt5core-devel
BuildRequires:	%{_lib}qt5dbus-devel
BuildRequires:  %{_lib}qt5help-devel
BuildRequires:	%{_lib}qt5qml-devel
BuildRequires:	%{_lib}qt5quick-devel
BuildRequires:	%{_lib}qt5quicktest-devel
BuildRequires:  libxcb-devel
BuildRequires:  pkgconfig
BuildRequires:  python-docutils

Requires:	consolekit-x11
Requires:	upower
Requires:	qtdeclarative5
Requires:	xinitrc

Conflicts: sddm < 0.14.0-4

%description
SDDM is a modern display manager for X11 aiming to be fast, simple and
beautiful. It uses modern technologies like QtQuick, which in turn gives the
designer the ability to create smooth, animated user interfaces.

%prep
%setup -q
%apply_patches

install -Dm755 %{SOURCE5} data/scripts/Xsession
install -m755 %{SOURCE6} data/scripts/Xsetup

%build
%cmake_qt5 \
  -DUSE_QT5=ON \
  -DBUILD_MAN_PAGES=ON \
  -DENABLE_JOURNALD=OFF \
  -DUID_MIN=500 \
  -DUID_MAX=60000
%make

%install
rm -rf %buildroot
%make_install -C build

%__install -Dm 644 %{SOURCE1} %{buildroot}%{_datadir}/X11/dm.d/11sddm.conf
%__install -Dm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/sddm
%__install -Dm 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/sddm-autologin
%__install -Dm 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/pam.d/sddm
%__install -Dm 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/sddm.conf
%__mkdir_p %{buildroot}%{_localstatedir}/lib/%{name}

# fix MinimumVT= option
#%__sed -i '/^MinimumVT=/s/=.*/=8/' %{buildroot}%{_sysconfdir}/sddm.conf

%pre
if [ "$1" = 1 ]; then
%_pre_useradd %{name} %{_localstatedir}/lib/%{name} /sbin/nologin
fi

%post
if [ "$1" = 1 ]; then
echo -e \
"\n------------------------------------------------------------------------------------
 1. To start using SDDM as main display manager go to:
 PCLinuxOS Control Center => Boot => Setup display manager. Make your choice,
 apply changes and reboot your computer.\n
 2. If you want get knowledge about all configuration options of SDDM consult
 with its manpage by command: man sddm.conf.\n
 3. If you are running KDE Plasma 5 you can configure SDDM display manager
 in graphical tool available in:
 KMenu -> Computer -> SystemSettings -> Startup and Shutdown -> Login Screen (SDDM).
------------------------------------------------------------------------------------\n"
fi

%posttrans
cat >/etc/pam.d/sddm << EOF
#%PAM-1.0
auth       required    pam_env.so
auth       sufficient  pam_succeed_if.so user ingroup nopasswdlogin
auth       include     system-auth
account    include     system-auth
password   include     system-auth
session    optional    pam_keyinit.so force revoke
session    required    pam_namespace.so
session    include     system-auth
session    optional    pam_console.so
session    optional    pam_ck_connector.so nox11
EOF

cat >/etc/pam.d/sddm-autologin << EOF
#%PAM-1.0
auth       required    pam_env.so
auth       required    pam_permit.so
account    required    pam_nologin.so
account    include     system-auth
password   include     system-auth
session    optional    pam_console.so
session    optional    pam_keyinit.so force revoke
session    required    pam_namespace.so
session    include     system-auth
session    required    pam_ck_connector.so nox11
EOF

if [ -f /etc/pam.d/sddm.rpmnew ]; then
/bin/rm -f /etc/pam.d/sddm.rpmnew 
fi

if [ -f /etc/pam.d/sddm-autologin.rpmnew ]; then
/bin/rm -f /etc/pam.d/sddm-autologin.rpmnew 
fi

%files
%doc LICENSE* README.md CONTRIBUTORS
%attr(700,sddm,sddm) %{_localstatedir}/lib/%{name}/
%config(noreplace) %{_sysconfdir}/sddm.conf
%config(noreplace) %{_sysconfdir}/pam.d/sddm
%config(noreplace) %{_sysconfdir}/pam.d/sddm-autologin
%config(noreplace) %{_sysconfdir}/pam.d/sddm-greeter

%{_sysconfdir}/dbus-1/system.d/org.freedesktop.DisplayManager.conf
%{_sysconfdir}/logrotate.d/sddm
%{_bindir}/sddm
%{_bindir}/sddm-greeter
%{_libexecdir}/sddm-helper
%{_qt5_qml}/SddmComponents
%{_mandir}/man?/%{name}*
%{_datadir}/sddm/faces
%{_datadir}/sddm/flags
%{_datadir}/sddm/scripts
%{_datadir}/sddm/themes
%{_datadir}/X11/dm.d/11sddm.conf
%{_datadir}/sddm/translations/

%changelog
* Mon Apr 09 2018 adrianomorselli <adrianomorselli> 0.14.0-6uplos2018
- fix Xsession so other DE work properly when
- using sddm as login manager
